#循环依赖检测时用到的一个异常类型,便于抛异常时传递参数
class CircularDependencyError < StandardError
  attr_accessor :from
  attr_accessor :to 
  attr_accessor :path
  attr_accessor :message

  # @param [String]         from      循环依赖上端点
  # @param [String]         to        循环依赖下端点
  # @param [Array<String>]  path      循环依赖路径上的节点名
  # @param [String]         message   附加消息
  def initialize(from, to , path , message = 'Circular dependency detected!')
    @from = from
    @to = to
    @path = path
    @message = message
  end

  def to_s
    path_message = String.new
    @path.each { |name|
      path_message << name + '--->'
    }
    path_message << @to

    "#{super} \n #{@message} \n #{@from} <---> #{@to} . \n Full Path: #{path_message} "
  end
  
end